/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT2.dat, Mon Dec 12 01:36:27 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000019F0 (6640)
 *     Revision         0x01
 *     Checksum         0xB3
 *     OEM ID           "AmdRef"
 *     OEM Table ID     "AmdTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */
DefinitionBlock ("SSDT2.aml", "SSDT", 1, "AmdRef", "AmdTabl", 0x00001000)
{
    External (EBAS, MethodObj)    // 1 Arguments
    External (PEBS)
    External (ASLB, MethodObj)    // 1 Arguments
    External (LIDS, MethodObj)    // 0 Arguments
    External (DSEN)
    External (PWRS, IntObj)
    External (NDID)
    External (DID7)
    External (DID6)
    External (DID5)
    External (DID4)
    External (DID3)
    External (DID2)
    External (DID1)
    External (AMDA, MethodObj)    // 1 Arguments
    External (\_SB_.LID0._LID)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.GFX0._DOD, IntObj)
    External (\_SB_.PCI0.GFX0.CLID)
    External (\_SB_.PCI0.GFX0.AINT, MethodObj)    // 2 Arguments
    External (\_SB_.PCI0.GFX0.GHDS, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.GFX0.GLID, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.P0P2.PEGP, DeviceObj)
    External (\_SB_.PCI0.GFX0.DD08._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD07._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD06._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD05._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD04._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD03._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCM, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BQC, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCL, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD01._ADR, IntObj)
    External (\_SB_.PCI0.P0P2.PEGP._ADR)
    External (\_SB_.PCI0.LPCB.H_EC.SCAN)
    External (\_SB_.PCI0.LPCB.EC__.VGAD, MethodObj)    // 1 Arguments

    Scope (\_SB.PCI0.P0P2.PEGP)
    {
        OperationRegion (GPIO, SystemIO, 0x0500, 0x60)
        Field (GPIO, ByteAcc, Lock, Preserve)
        {
                    Offset (0x0C), 
                    Offset (0x0E), 
            PO16,   1, 
            PI17,   1, 
                    Offset (0x38), 
                ,   4, 
            PO36,   1, 
            PI37,   1, 
                ,   14, 
            PO52,   1, 
            PO53,   1, 
                    Offset (0x48), 
            PO64,   1
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_DSM, 4, Serialized)
        {
            Store (And (Arg2, 0xFF), Local0)
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                If (LEqual (Arg2, Zero))
                {
                    Return (Buffer (0x04)
                    {
                        0x03, 0x00, 0x00, 0x00
                    })
                }

                If (LEqual (Arg2, One))
                {
                    Return (Package (0x08)
                    {
                        0x07, 
                        Package (0x02)
                        {
                            0x80010100, 
                            Buffer (0x04)
                            {
                                0x01, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010400, 
                            Buffer (0x04)
                            {
                                0x02, 0x03, 0x03, 0x00
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010300, 
                            Buffer (0x04)
                            {
                                0x08, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010301, 
                            Buffer (0x04)
                            {
                                0x04, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010302, 
                            Buffer (0x04)
                            {
                                0x05, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010303, 
                            Buffer (0x04)
                            {
                                0x0A, 0x03, 0x03, 0x03
                            }
                        }, 

                        Package (0x02)
                        {
                            0x80010304, 
                            Buffer (0x04)
                            {
                                0x06, 0x03, 0x03, 0x03
                            }
                        }
                    })
                }

                Return (One)
            }

            Return (One)
        }

        OperationRegion (APXM, SystemMemory, AMDA (0x00010400), Field (APXM, AnyAcc, NoLock, Preserve)
            {
                APSG,   128, 
                APSZ,   32, 
                APVR,   32, 
                        Offset (0x100), 
                APXA,   32, 
                RVBS,   32, 
                TVBO,   32, 
                PXEN,   8, 
                        Offset (0x180), 
                NTLE,   16, 
                TLE1,   16, 
                TLE2,   16, 
                TLE3,   16, 
                TLE4,   16, 
                TLE5,   16, 
                TLE6,   16, 
                TLE7,   16, 
                TLE8,   16, 
                TLE9,   16, 
                TL10,   16, 
                TL11,   16, 
                TL12,   16, 
                TL13,   16, 
                TL14,   16, 
                TL15,   16, 
                        Offset (0x200), 
                TGXA,   16, 
                AGXA,   16, 
                GSTP,   8, 
                        Offset (0x210), 
                DSWR,   8, 
                EMDR,   8, 
                TSTR,   8, 
                FPSR,   8, 
                SPSR,   8, 
                DCFR,   8, 
                        Offset (0x230), 
                TSTG,   8, 
                TSSI,   8, 
                FPTG,   8, 
                FPSI,   8, 
                SPWS,   8, 
                        Offset (0x250), 
                SUPD,   16, 
                CACD,   16, 
                CCND,   16, 
                NACD,   16, 
                TLST,   8, 
                LDST,   8, 
                        Offset (0x3C0), 
                TVSD,   8, 
                EXPM,   8, 
                BPSD,   16, 
                BSPD,   16, 
                TLSN,   16, 
                        Offset (0x400), 
                RBF1,   262144, 
                RBF2,   262144
            })
        Method (ATPX, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Name (TMP1, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP1, Zero, F0SS)
                CreateWordField (TMP1, 0x02, F0IV)
                CreateDWordField (TMP1, 0x04, F0SF)
                Store (0x08, F0SS)
                Store (One, F0IV)
                Store (0xBF, F0SF)
                Return (TMP1)
            }

            If (LEqual (Arg0, One))
            {
                Name (TMP2, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP2, Zero, F1SS)
                CreateDWordField (TMP2, 0x02, F1VM)
                CreateDWordField (TMP2, 0x06, F1FG)
                Store (0x0A, F1SS)
                Store (0x40, F1VM)
                Store (0x40, F1FG)
                Return (TMP2)
            }

            If (LEqual (Arg0, 0x02))
            {
                CreateWordField (Arg1, Zero, FN2S)
                CreateByteField (Arg1, 0x02, DGPR)
                If (LEqual (DGPR, Zero))
                {
                    \_SB.PCI0.P0P2.PEGP._OFF ()
                }

                If (LEqual (DGPR, One))
                {
                    \_SB.PCI0.P0P2.PEGP._ON ()
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x03))
            {
                CreateWordField (Arg1, Zero, FN3S)
                CreateWordField (Arg1, 0x02, SDMG)
                If (LEqual (SDMG, Zero))
                {
                    If (Zero)
                    {
                        Store (Zero, \_SB.PCI0.P0P2.PEGP.PO52)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.P0P2.PEGP.PO52)
                        \_SB.PCI0.LPCB.EC.VGAD (One)
                    }
                }

                If (LEqual (SDMG, One))
                {
                    If (Ones)
                    {
                        Store (Zero, \_SB.PCI0.P0P2.PEGP.PO52)
                        \_SB.PCI0.LPCB.EC.VGAD (Zero)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.P0P2.PEGP.PO52)
                    }
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x04))
            {
                CreateWordField (Arg1, Zero, FN4S)
                CreateWordField (Arg1, 0x02, SIMG)
                If (LEqual (SIMG, Zero))
                {
                    If (Zero)
                    {
                        Store (Zero, \_SB.PCI0.P0P2.PEGP.PO64)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.P0P2.PEGP.PO64)
                    }
                }

                If (LEqual (SIMG, One))
                {
                    If (Ones)
                    {
                        Store (Zero, \_SB.PCI0.P0P2.PEGP.PO64)
                    }
                    Else
                    {
                        Store (One, \_SB.PCI0.P0P2.PEGP.PO64)
                    }
                }

                Return (Zero)
            }

            If (LEqual (Arg0, 0x05))
            {
                CreateWordField (Arg1, Zero, FN5S)
                CreateWordField (Arg1, 0x02, TGFX)
                Store (TGFX, TGXA)
                Store (One, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x06))
            {
                CreateWordField (Arg1, Zero, FN6S)
                CreateWordField (Arg1, 0x02, AGFX)
                Store (AGFX, AGXA)
                Store (Zero, GSTP)
                Return (Zero)
            }

            If (LEqual (Arg0, 0x08))
            {
                Name (TMP3, Buffer (0x0100)
                {
                    0x00
                })
                CreateWordField (TMP3, Zero, NOCN)
                CreateWordField (TMP3, 0x02, CNSS)
                Store (0x09, NOCN)
                Store (0x2D, CNSS)
                CreateByteField (TMP3, 0x04, FLG1)
                CreateByteField (TMP3, 0x05, ATI1)
                CreateByteField (TMP3, 0x06, ADI1)
                CreateWordField (TMP3, 0x07, ACP1)
                Store (0x07, FLG1)
                Store (One, ATI1)
                Store (Zero, ADI1)
                Store (0x0100, ACP1)
                CreateByteField (TMP3, 0x09, FLG2)
                CreateByteField (TMP3, 0x0A, ATI2)
                CreateByteField (TMP3, 0x0B, ADI2)
                CreateWordField (TMP3, 0x0C, ACP2)
                Store (0x07, FLG2)
                Store (One, ATI2)
                Store (One, ADI2)
                Store (0x0100, ACP2)
                CreateByteField (TMP3, 0x0E, FLG3)
                CreateByteField (TMP3, 0x0F, ATI3)
                CreateByteField (TMP3, 0x10, ADI3)
                CreateWordField (TMP3, 0x11, ACP3)
                Store (0x05, FLG3)
                Store (Zero, ATI3)
                Store (Zero, ADI3)
                Store (0x0400, ACP3)
                CreateByteField (TMP3, 0x13, FLG4)
                CreateByteField (TMP3, 0x14, ATI4)
                CreateByteField (TMP3, 0x15, ADI4)
                CreateWordField (TMP3, 0x16, ACP4)
                Store (0x05, FLG4)
                Store (Zero, ATI4)
                Store (One, ADI4)
                Store (0x0110, ACP4)
                CreateByteField (TMP3, 0x18, FLG5)
                CreateByteField (TMP3, 0x19, ATI5)
                CreateByteField (TMP3, 0x1A, ADI5)
                CreateWordField (TMP3, 0x1B, ACP5)
                Store (0x07, FLG5)
                Store (0x09, ATI5)
                Store (One, ADI5)
                Store (0x0230, ACP5)
                CreateByteField (TMP3, 0x1D, FLG6)
                CreateByteField (TMP3, 0x1E, ATI6)
                CreateByteField (TMP3, 0x1F, ADI6)
                CreateWordField (TMP3, 0x20, ACP6)
                Store (0x07, FLG6)
                Store (0x03, ATI6)
                Store (One, ADI6)
                Store (0x0210, ACP6)
                CreateByteField (TMP3, 0x22, FLG7)
                CreateByteField (TMP3, 0x23, ATI7)
                CreateByteField (TMP3, 0x24, ADI7)
                CreateWordField (TMP3, 0x25, ACP7)
                Store (0x07, FLG7)
                Store (0x0A, ATI7)
                Store (One, ADI7)
                Store (0x0240, ACP7)
                CreateByteField (TMP3, 0x27, FLG8)
                CreateByteField (TMP3, 0x28, ATI8)
                CreateByteField (TMP3, 0x29, ADI8)
                CreateWordField (TMP3, 0x2A, ACP8)
                Store (0x07, FLG8)
                Store (0x07, ATI8)
                Store (One, ADI8)
                Store (0x0220, ACP8)
                CreateByteField (TMP3, 0x2C, FLG9)
                CreateByteField (TMP3, 0x2D, ATI9)
                CreateByteField (TMP3, 0x2E, ADI9)
                CreateWordField (TMP3, 0x2F, ACP9)
                Store (0x07, FLG9)
                Store (0x0B, ATI9)
                Store (One, ADI9)
                Store (0x0250, ACP9)
                Return (TMP3)
            }

            Return (Zero)
        }

        Method (ATRM, 2, Serialized)
        {
            Store (Arg0, Local0)
            Store (Arg1, Local1)
            If (LGreater (Local1, 0x1000))
            {
                Store (0x1000, Local1)
            }

            If (LGreater (Local0, 0x00010000))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            If (LGreater (Local0, RVBS))
            {
                Return (Buffer (Local1)
                {
                    0x00
                })
            }

            Multiply (Local1, 0x08, Local3)
            Name (ROM1, Buffer (0x8000)
            {
                0x00
            })
            Name (ROM2, Buffer (Local1)
            {
                0x00
            })
            If (LLess (Local0, 0x8000))
            {
                Store (RBF1, ROM1)
            }
            Else
            {
                Subtract (Local0, 0x8000, Local0)
                Store (RBF2, ROM1)
            }

            Multiply (Local0, 0x08, Local2)
            CreateField (ROM1, Local2, Local3, TMPB)
            Store (TMPB, ROM2)
            Return (ROM2)
        }
    }

    Method (IDAB, 0, Serialized)
    {
        Store (0x80010100, DID1)
        Store (0x80010400, DID2)
        Store (0x80010300, DID3)
        Store (0x80010301, DID4)
        Store (0x80010302, DID5)
        Store (0x80010303, DID6)
        Store (0x80010304, DID7)
        Store (0x07, NDID)
    }

    Method (HGAS, 0, Serialized)
    {
        If (PWRS)
        {
            Store (One, \_SB.PCI0.GFX0.SPWS)
        }
        Else
        {
            Store (0x02, \_SB.PCI0.GFX0.SPWS)
        }

        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            Store (One, \_SB.PCI0.GFX0.SPSR)
            Notify (\_SB.PCI0.GFX0, 0x81)
        }
    }

    Method (HBRT, 1, Serialized)
    {
        If (And (0x04, DSEN))
        {
            If (LEqual (Arg0, 0x04))
            {
                Notify (\_SB.PCI0.P0P2.PEGP.DD02, 0x87)
            }

            If (LEqual (Arg0, 0x03))
            {
                Notify (\_SB.PCI0.P0P2.PEGP.DD02, 0x86)
            }
        }
    }

    Method (HLSE, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.GLID (LIDS ())
            }
        }
    }

    Method (HDSE, 1, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.GHDS (Arg0)
            }
            Else
            {
                Store (One, \_SB.PCI0.GFX0.DSWR)
                Subtract (\_SB.PCI0.LPCB.H_EC.SCAN, 0x3A, \_SB.PCI0.GFX0.TLST)
                Notify (\_SB.PCI0.GFX0, 0x81)
            }
        }
    }

    Method (HPFS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                \_SB.PCI0.GFX0.AINT (0x02, Zero)
            }
            Else
            {
                Store (One, \_SB.PCI0.GFX0.EMDR)
                If (LEqual (\_SB.PCI0.GFX0.EXPM, 0x02))
                {
                    Store (Zero, \_SB.PCI0.GFX0.EXPM)
                }
                Else
                {
                    Increment (\_SB.PCI0.GFX0.EXPM)
                }

                Notify (\_SB.PCI0.GFX0, 0x81)
            }
        }
    }

    Method (HGLS, 0, Serialized)
    {
        If (LNotEqual (\_SB.PCI0.GFX0.GSTP, One))
        {
            If (LEqual (\_SB.PCI0.GFX0.AGXA, Zero))
            {
                If (\_SB.PCI0.GFX0.GLID (LIDS ()))
                {
                    Or (0x80000000, \_SB.PCI0.GFX0.CLID, \_SB.PCI0.GFX0.CLID)
                }
            }
        }
    }

    Method (FPED, 0, NotSerialized)
    {
        OperationRegion (IGDM, SystemMemory, ASLB (0x2000), Field (IGDM, AnyAcc, NoLock, Preserve)
            {
                        Offset (0x1C04), 
                DDCH,   1024
            })
    }

    Method (PDCC, 0, NotSerialized)
    {
        Store (One, \_SB.PCI0.GFX0.DCFR)
        Notify (\_SB.PCI0.GFX0, 0x81)
    }

    Method (PXPW, 0, Serialized)
    {
        If (PWRS)
        {
            Store (One, \_SB.PCI0.GFX0.SPWS)
        }
        Else
        {
            Store (0x02, \_SB.PCI0.GFX0.SPWS)
        }
    }

    Scope (\_SB.PCI0.GFX0)
    {
        Method (COTA, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (TLE1, Arg0))
                {
                    Return (One)
                }

                If (LEqual (TLE2, Arg0))
                {
                    Return (0x02)
                }

                If (LEqual (TLE3, Arg0))
                {
                    Return (0x03)
                }

                If (LEqual (TLE4, Arg0))
                {
                    Return (0x04)
                }

                If (LEqual (TLE5, Arg0))
                {
                    Return (0x05)
                }

                If (LEqual (TLE6, Arg0))
                {
                    Return (0x06)
                }

                If (LEqual (TLE7, Arg0))
                {
                    Return (0x07)
                }

                If (LEqual (TLE8, Arg0))
                {
                    Return (0x08)
                }

                If (LEqual (TLE9, Arg0))
                {
                    Return (0x09)
                }

                If (LEqual (TL10, Arg0))
                {
                    Return (0x0A)
                }

                If (LEqual (TL11, Arg0))
                {
                    Return (0x0B)
                }

                If (LEqual (TL12, Arg0))
                {
                    Return (0x0C)
                }

                If (LEqual (TL13, Arg0))
                {
                    Return (0x0D)
                }

                If (LEqual (TL14, Arg0))
                {
                    Return (0x0E)
                }

                If (LEqual (TL15, Arg0))
                {
                    Return (0x0F)
                }
            }

            Return (Zero)
        }

        Method (NATL, 1, NotSerialized)
        {
            If (LNotEqual (NTLE, Zero))
            {
                If (LEqual (Arg0, One))
                {
                    Return (TLE2)
                }

                If (LEqual (Arg0, 0x02))
                {
                    Return (TLE3)
                }

                If (LEqual (Arg0, 0x03))
                {
                    Return (TLE4)
                }

                If (LEqual (Arg0, 0x04))
                {
                    Return (TLE5)
                }

                If (LEqual (Arg0, 0x05))
                {
                    Return (TLE6)
                }

                If (LEqual (Arg0, 0x06))
                {
                    Return (TLE7)
                }

                If (LEqual (Arg0, 0x07))
                {
                    Return (TLE8)
                }

                If (LEqual (Arg0, 0x08))
                {
                    Return (TLE9)
                }

                If (LEqual (Arg0, 0x09))
                {
                    Return (TL10)
                }

                If (LEqual (Arg0, 0x0A))
                {
                    Return (TL11)
                }

                If (LEqual (Arg0, 0x0B))
                {
                    Return (TL12)
                }

                If (LEqual (Arg0, 0x0C))
                {
                    Return (TL13)
                }

                If (LEqual (Arg0, 0x0D))
                {
                    Return (TL14)
                }

                If (LEqual (Arg0, 0x0E))
                {
                    Return (TL15)
                }

                If (LEqual (Arg0, 0x0F))
                {
                    Return (TLE1)
                }
            }

            Return (Zero)
        }

        Name (ATIB, Buffer (0x0100) {})
        Method (ATIF, 2, Serialized)
        {
            If (LEqual (Arg0, Zero))
            {
                Return (AF00 ())
            }

            If (LEqual (Arg0, One))
            {
                Return (AF01 ())
            }

            If (LEqual (Arg0, 0x02))
            {
                Return (AF02 ())
            }

            If (LEqual (Arg0, 0x03))
            {
                Return (AF03 (DerefOf (Index (Arg1, 0x02)), DerefOf (Index (Arg1, 
                    0x04))))
            }
            Else
            {
                CreateWordField (ATIB, Zero, SSZE)
                CreateWordField (ATIB, 0x02, VERN)
                CreateDWordField (ATIB, 0x04, NMSK)
                CreateDWordField (ATIB, 0x08, SFUN)
                Store (Zero, SSZE)
                Store (Zero, VERN)
                Store (Zero, NMSK)
                Store (Zero, SFUN)
                Return (ATIB)
            }
        }

        Method (AF00, 0, NotSerialized)
        {
            CreateWordField (ATIB, Zero, SSZE)
            CreateWordField (ATIB, 0x02, VERN)
            CreateDWordField (ATIB, 0x04, NMSK)
            CreateDWordField (ATIB, 0x08, SFUN)
            Store (0x0C, SSZE)
            Store (One, VERN)
            Store (0x51, NMSK)
            Store (NMSK, MSKN)
            Store (0x07, SFUN)
            Return (ATIB)
        }

        Name (NCOD, 0x81)
        Method (AF01, 0, NotSerialized)
        {
            CreateWordField (ATIB, Zero, SSZE)
            CreateDWordField (ATIB, 0x02, VMSK)
            CreateDWordField (ATIB, 0x06, FLGS)
            Store (0x03, VMSK)
            Store (0x0A, SSZE)
            Store (One, FLGS)
            Store (0x81, NCOD)
            Return (ATIB)
        }

        Name (PSBR, Buffer (0x04)
        {
            0x00, 0x00, 0x00, 0x00
        })
        Name (MSKN, Zero)
        Name (SEXM, Zero)
        Name (STHG, Zero)
        Name (STHI, Zero)
        Name (SFPG, Zero)
        Name (SFPI, Zero)
        Name (SSPS, Zero)
        Name (SSDM, 0x0A)
        Name (SCDY, Zero)
        Name (SACT, Buffer (0x06)
        {
            0x01, 0x02, 0x08, 0x03, 0x09, 0x0A
        })
        Method (AF02, 0, NotSerialized)
        {
            CreateBitField (PSBR, Zero, PDSW)
            CreateBitField (PSBR, One, PEXM)
            CreateBitField (PSBR, 0x02, PTHR)
            CreateBitField (PSBR, 0x03, PFPS)
            CreateBitField (PSBR, 0x04, PSPS)
            CreateBitField (PSBR, 0x05, PDCC)
            CreateBitField (PSBR, 0x06, PXPS)
            CreateWordField (ATIB, Zero, SSZE)
            CreateDWordField (ATIB, 0x02, PSBI)
            CreateByteField (ATIB, 0x06, EXPM)
            CreateByteField (ATIB, 0x07, THRM)
            CreateByteField (ATIB, 0x08, THID)
            CreateByteField (ATIB, 0x09, FPWR)
            CreateByteField (ATIB, 0x0A, FPID)
            CreateByteField (ATIB, 0x0B, SPWR)
            Store (0x0C, SSZE)
            Store (PSBR, PSBI)
            If (PDSW)
            {
                Store (Zero, PDSW)
            }

            If (PEXM)
            {
                Store (SEXM, EXPM)
                Store (Zero, SEXM)
                Store (Zero, PEXM)
            }

            If (PTHR)
            {
                Store (STHG, THRM)
                Store (STHI, THID)
                Store (Zero, STHG)
                Store (Zero, STHI)
                Store (Zero, PTHR)
            }

            If (PFPS)
            {
                Store (SFPG, FPWR)
                Store (SFPI, FPWR)
                Store (Zero, SFPG)
                Store (Zero, SFPI)
                Store (Zero, PFPS)
            }

            If (PSPS)
            {
                Store (SSPS, SPWR)
                Store (Zero, PSPS)
            }

            If (PXPS)
            {
                Store (Zero, PXPS)
            }

            Return (ATIB)
        }

        Method (AF03, 2, NotSerialized)
        {
            CreateWordField (ATIB, Zero, SSZE)
            CreateWordField (ATIB, 0x02, SSDP)
            CreateWordField (ATIB, 0x04, SCDP)
            Store (Arg0, SSDP)
            Store (Arg1, SCDP)
            Name (NXTD, 0x06)
            Name (CIDX, 0x06)
            Store (SSDP, Local1)
            And (Local1, 0x0B, Local1)
            Store (SCDP, Local2)
            If (CondRefOf (\_SB.LID0._LID, Local4))
            {
                And (Local2, 0xFFFFFFFE, Local2)
                Or (Local2, \_SB.LID0._LID, Local2)
            }
            Else
            {
                Or (Local2, One, Local2)
            }

            Store (Zero, Local0)
            While (LLess (Local0, SizeOf (SACT)))
            {
                Store (DerefOf (Index (SACT, Local0)), Local3)
                If (LEqual (Local3, Local1))
                {
                    Store (Local0, CIDX)
                    Store (SizeOf (SACT), Local0)
                }
                Else
                {
                    Increment (Local0)
                }
            }

            Store (CIDX, Local0)
            While (LLess (Local0, SizeOf (SACT)))
            {
                Increment (Local0)
                If (LEqual (Local0, SizeOf (SACT)))
                {
                    Store (Zero, Local0)
                }

                Store (DerefOf (Index (SACT, Local0)), Local3)
                If (LEqual (And (Local3, Local2), Local3))
                {
                    Store (Local0, NXTD)
                    Store (SizeOf (SACT), Local0)
                }
            }

            If (LEqual (NXTD, SizeOf (SACT)))
            {
                Store (Zero, SSDP)
            }
            Else
            {
                Store (NXTD, Local0)
                Store (DerefOf (Index (SACT, Local0)), Local3)
                And (SSDP, 0xFFFFFFF4, SSDP)
                Or (SSDP, Local3, SSDP)
            }

            Store (0x04, SSZE)
            Return (ATIB)
        }

        Method (AFN0, 0, Serialized)
        {
            If (And (MSKN, One))
            {
                CreateBitField (PSBR, Zero, PDSW)
                Store (One, PDSW)
                Notify (GFX0, NCOD)
            }
        }

        Method (AFN3, 2, Serialized)
        {
            If (And (MSKN, 0x08))
            {
                Store (Arg0, Local0)
                Store (Local0, SFPI)
                Store (Arg1, Local0)
                Store (And (Local0, 0x03, Local0), SFPG)
                CreateBitField (PSBR, 0x03, PFPS)
                Store (One, PFPS)
                Notify (GFX0, NCOD)
            }
        }

        Method (AFN4, 1, Serialized)
        {
            If (And (MSKN, 0x10))
            {
                Store (Arg0, Local0)
                Store (SSPS, Local1)
                Store (Local0, SSPS)
                If (LEqual (Local0, Local1)) {}
                Else
                {
                    CreateBitField (PSBR, 0x04, PSPS)
                    Store (One, PSPS)
                    Notify (GFX0, NCOD)
                }
            }
        }

        Method (AFN5, 0, Serialized)
        {
            If (And (MSKN, 0x20))
            {
                CreateBitField (PSBR, 0x05, PDCC)
                Store (One, PDCC)
                Notify (GFX0, NCOD)
            }
        }

        Method (AFN6, 0, Serialized)
        {
            If (And (MSKN, 0x40))
            {
                CreateBitField (PSBR, 0x06, PXPS)
                Store (One, PXPS)
                Notify (GFX0, NCOD)
            }
        }
    }

    Scope (\_SB.PCI0.P0P2)
    {
        Name (B0D1, Zero)
        OperationRegion (RPCI, SystemMemory, Or (PEBS, 0x8000, B0D1), 0x1000)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
                    Offset (0x214), 
                    Offset (0x216), 
            LNKS,   4, 
                    Offset (0x224), 
                    Offset (0x225), 
            DQDA,   1, 
                    Offset (0xC28), 
            HCLQ,   1, 
                    Offset (0xC34), 
                ,   30, 
            PEDQ,   1, 
            PIDQ,   1, 
                    Offset (0xDFC), 
            PEPO,   3, 
                    Offset (0xE08), 
                ,   31, 
            ROE0,   1, 
                    Offset (0xE28), 
                ,   31, 
            ROE1,   1, 
                    Offset (0xE48), 
                ,   31, 
            ROE2,   1, 
                    Offset (0xE68), 
                ,   31, 
            ROE3,   1, 
                    Offset (0xE88), 
                ,   31, 
            ROE4,   1, 
                    Offset (0xEA8), 
                ,   31, 
            ROE5,   1, 
                    Offset (0xEC8), 
                ,   31, 
            ROE6,   1, 
                    Offset (0xEE8), 
                ,   31, 
            ROE7,   1, 
                    Offset (0xF08), 
                ,   31, 
            ROE8,   1, 
                    Offset (0xF28), 
                ,   31, 
            ROE9,   1, 
                    Offset (0xF48), 
                ,   31, 
            ROEA,   1, 
                    Offset (0xF68), 
                ,   31, 
            ROEB,   1, 
                    Offset (0xF88), 
                ,   31, 
            ROEC,   1, 
                    Offset (0xFA8), 
                ,   31, 
            ROED,   1, 
                    Offset (0xFC8), 
                ,   31, 
            ROEE,   1, 
                    Offset (0xFE8), 
                ,   31, 
            ROEF,   1
        }

        OperationRegion (DMIB, SystemMemory, 0xFED18000, 0x1000)
        Field (DMIB, DWordAcc, Lock, Preserve)
        {
                    Offset (0xC34), 
            LLGE,   1, 
                ,   28, 
            PCGE,   1, 
                ,   1, 
            LGGE,   1
        }
    }

    Device (\_SB.PCI0.P0P2.HDAD)
    {
        Name (_ADR, One)
        OperationRegion (PCIC, PCI_Config, Zero, 0xFF)
        Field (PCIC, ByteAcc, NoLock, Preserve)
        {
                    Offset (0x4C), 
            SSSV,   32, 
                    Offset (0x68), 
            ASPM,   8
        }
    }

    Scope (\_SB.PCI0.P0P2.PEGP)
    {
        OperationRegion (PCIS, SystemMemory, EBAS (0x0100), Field (PCIS, DWordAcc, Lock, Preserve)
            {
                        Offset (0x4C), 
                SSID,   32, 
                        Offset (0x68), 
                ASPM,   8
            })
        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.P0P2.PEGP._ADR)
        }

        Method (_ON, 0, Serialized)
        {
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.P0P2.PEGP.PO16)
            }
            Else
            {
                Store (One, \_SB.PCI0.P0P2.PEGP.PO16)
            }

            If (Ones)
            {
                Store (Zero, \_SB.PCI0.P0P2.PEGP.PO36)
            }
            Else
            {
                Store (One, \_SB.PCI0.P0P2.PEGP.PO36)
            }

            Sleep (0x012C)
            If (Zero)
            {
                Store (Zero, \_SB.PCI0.P0P2.PEGP.PO16)
            }
            Else
            {
                Store (One, \_SB.PCI0.P0P2.PEGP.PO16)
            }

            Sleep (0x64)
            Store (Zero, LLGE)
            Store (Zero, LGGE)
            Store (Zero, PEPO)
            Store (Zero, ROE0)
            Store (Zero, ROE1)
            Store (Zero, ROE2)
            Store (Zero, ROE3)
            Store (Zero, ROE4)
            Store (Zero, ROE5)
            Store (Zero, ROE6)
            Store (Zero, ROE7)
            Store (Zero, ROE8)
            Store (Zero, ROE9)
            Store (Zero, ROEA)
            Store (Zero, ROEB)
            Store (Zero, ROEC)
            Store (Zero, ROED)
            Store (Zero, ROEE)
            Store (Zero, ROEF)
            Store (Zero, PCGE)
            Store (Zero, HCLQ)
            Store (Zero, PEDQ)
            Store (Zero, LNKD)
            Store (One, LLGE)
            Store (One, LGGE)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Store (0x143A103C, SSID)
            Store (0x143A103C, \_SB.PCI0.P0P2.HDAD.SSSV)
            Store (0x43, \_SB.PCI0.P0P2.PEGP.ASPM)
            Store (0x43, \_SB.PCI0.P0P2.HDAD.ASPM)
            \_SB.PCI0.LPCB.EC.VGAD (Zero)
            Notify (\_SB.PCI0.P0P2, Zero)
        }

        Method (_OFF, 0, Serialized)
        {
            \_SB.PCI0.LPCB.EC.VGAD (One)
            Store (Zero, LLGE)
            Store (Zero, LGGE)
            Store (One, LNKD)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            Store (One, PEDQ)
            Store (Zero, LNKD)
            While (LNotEqual (PIDQ, One))
            {
                Sleep (One)
            }

            Store (One, PCGE)
            Store (One, HCLQ)
            Store (0x07, PEPO)
            Store (One, ROE0)
            Store (One, ROE1)
            Store (One, ROE2)
            Store (One, ROE3)
            Store (One, ROE4)
            Store (One, ROE5)
            Store (One, ROE6)
            Store (One, ROE7)
            Store (One, ROE8)
            Store (One, ROE9)
            Store (One, ROEA)
            Store (One, ROEB)
            Store (One, ROEC)
            Store (One, ROED)
            Store (One, ROEE)
            Store (One, ROEF)
            Store (One, LLGE)
            Store (One, LGGE)
            If (Ones)
            {
                Store (Zero, \_SB.PCI0.P0P2.PEGP.PO16)
            }
            Else
            {
                Store (One, \_SB.PCI0.P0P2.PEGP.PO16)
            }

            If (Zero)
            {
                Store (Zero, \_SB.PCI0.P0P2.PEGP.PO36)
            }
            Else
            {
                Store (One, \_SB.PCI0.P0P2.PEGP.PO36)
            }

            Notify (\_SB.PCI0.P0P2, Zero)
        }

        Method (_STA, 0, Serialized)
        {
            If (Ones)
            {
                If (LEqual (\_SB.PCI0.P0P2.PEGP.PO36, Zero))
                {
                    Return (0x0F)
                }
            }
            Else
            {
                If (LEqual (\_SB.PCI0.P0P2.PEGP.PO36, One))
                {
                    Return (0x0F)
                }
            }

            Return (Zero)
        }

        Method (_DOD, 0, NotSerialized)
        {
            Return (\_SB.PCI0.GFX0._DOD)
        }

        Device (DD01)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD01._ADR)
            }
        }

        Device (DD02)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._ADR)
            }

            Method (_BCL, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCL)
            }

            Method (_BQC, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BQC)
            }

            Method (_BCM, 1, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCM)
                Arg0
            }
        }

        Device (DD03)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD03._ADR)
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD04._ADR)
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD05._ADR)
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD06._ADR)
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD07._ADR)
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD08._ADR)
            }
        }
    }
}

